Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.renderReactWithStyledComponentsStatic = exports.renderReactWithStyledComponents = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _server = require('react-dom/server');

var _server2 = _interopRequireDefault(_server);

var _hypernova = require('hypernova');

var _hypernova2 = _interopRequireDefault(_hypernova);

var _styledComponents = require('styled-components');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var renderReactWithStyledComponents = exports.renderReactWithStyledComponents = function renderReactWithStyledComponents(name, component) {
  return (0, _hypernova2['default'])({
    server: function () {
      function server() {
        return function (props) {
          var sheet = new _styledComponents.ServerStyleSheet();
          var element = _react2['default'].createElement(component, props);
          var html = _server2['default'].renderToStaticMarkup(element);
          var css = sheet.getStyleTags();
          var markup = (0, _hypernova.serialize)(name, html, props);
          return String(css) + '\n' + String(markup);
        };
      }

      return server;
    }(),
    client: function () {
      function client() {
        var payloads = (0, _hypernova.load)(name);
        if (payloads) {
          payloads.forEach(function (payload) {
            var node = payload.node,
                data = payload.data;

            if (node) {
              var element = _react2['default'].createElement(component, data);
              if (_reactDom2['default'].hydrate) {
                _reactDom2['default'].hydrate(element, node);
              } else {
                _reactDom2['default'].render(element, node);
              }
            }
          });
        }

        return component;
      }

      return client;
    }()
  });
};

var renderReactWithStyledComponentsStatic = exports.renderReactWithStyledComponentsStatic = function renderReactWithStyledComponentsStatic(name, component) {
  return (0, _hypernova2['default'])({
    server: function () {
      function server() {
        return function (props) {
          var sheet = new _styledComponents.ServerStyleSheet();
          var element = _react2['default'].createElement(component, props);
          var html = _server2['default'].renderToStaticMarkup(element);
          var css = sheet.getStyleTags();
          return String(css) + '\n' + String(html);
        };
      }

      return server;
    }(),
    client: function () {
      function client() {}

      return client;
    }()
  });
};